using System;
using System.Collections.Generic;
using System.Collections;
using System.Text;
using TestCalendarService.CalendarService;

namespace TestCalendarService
{
    /// <summary>
    /// Test Java Based Calendar Web Service.
    /// Call all Webmethods
    /// </summary>
    class Program
    {
        static void Main(string[] args)
        {
            bool result;
            String  username = "testuser";
            String  password = "test123";
            List<AppointmentType> types = new List<AppointmentType>();
            CalendarService.CalendarService service = new TestCalendarService.CalendarService.CalendarService();
            
            // Create User
            result = service.createUser(username, password);
            Console.WriteLine("CREATE USER:" + result);

            // Create Appointment Type
            result = service.createType("Business Lunch");
            Console.WriteLine("CREATE TYPE:" + result);

            // Fetch Appointment Types
            stringArray[] CalendarTypes = service.getTypes();
            for (int i = 0; i < CalendarTypes.Length; i++)
            {
                String[] atype = CalendarTypes[i].item;
                if(atype.Length==2) {
                    AppointmentType type = new AppointmentType(atype[0],atype[1]);
                    types.Add(type);
                }
            }

            Console.WriteLine("PRINTING ALL FOUND TYPES:");
            AppointmentType[] typeArray = types.ToArray();
            for (int i = 0; i < typeArray.Length; i++)
            {
                Console.WriteLine(typeArray[i].ToString());
            }
          
            
            // Create Appointment
            String appResult = service.createAppointment(username,password,"Test Appointment","Just a Test",""+new DateTime().Millisecond,typeArray[0].id,1);
            if (appResult.Equals("")) Console.WriteLine("Fehler, berspringe Lschen");
            else
            {
                Console.WriteLine("AppID:" + appResult);

                // Delete Appointment
                result = service.deleteAppointment(username, password, appResult);
                Console.WriteLine("DELETE APPOINTMENT:" + result);
            }
            // Delete User
            result = service.deleteUser(username, password);
            Console.WriteLine("DELETE USER:" + result);
            
            // Create another user
            result = service.createUser(username, password);
            Console.WriteLine("CREATE USER:" + result);
            appResult = service.createAppointment(username, password, "App1", "Test Appointment 1",""+ new DateTime().Millisecond, typeArray[0].id, 1);
            Console.WriteLine("APPOINTMENT1:" + appResult);
            appResult = service.createAppointment(username, password, "App2", "Test Appointment 1",""+ new DateTime().Millisecond, typeArray[0].id, 1);
            Console.WriteLine("APPOINTMENT2:" + appResult);
            appResult = service.createAppointment(username, password, "App3", "Test Appointment 1",""+ new DateTime().Millisecond, typeArray[0].id, 1);
            Console.WriteLine("APPOINTMENT3:" + appResult);

            stringArray[] apps = service.getAppointments(username,password);
            for (int i = 0; i < apps.Length; i++)
            {
                String[] appointment = apps[i].item;
                for (int j = 0; j < appointment.Length; j++)
                {
                    Console.Write(appointment[j]+" ");
                }
                Console.WriteLine();
            }


            // Delete User and implicit all appointments
            result = service.deleteUser(username, password);
            Console.WriteLine("DELETE USER:" + result);

            Console.WriteLine("Press any key");
            Console.ReadKey();
        }
    }
}
